DCMTK: DcmPixelData Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Private Member Functions | Private Attributes | Friends | List of all members
DcmPixelData Class Reference

The class DcmPixelData stores different pixel representations identified by a type (the transfer syntax) and some representation parameters The three unencapsulated transfer syntaxes belong to the same pixel representation. More...

Inheritance diagram for DcmPixelData:

## Public Member Functions
| DcmPixelData (const DcmTag &tag, const Uint32 len=0)
| constructor.
| DcmPixelData (const DcmPixelData &pixelData)
| copy constructor
virtual | ~DcmPixelData ()
| destructor
DcmPixelData & | operator= (const DcmPixelData &obj)
| copy assignment operator
virtual DcmObject * | clone () const
| clone method
virtual int | compare (const DcmElement &rhs) const
| comparison operator that compares the value of this element with a given element of the same type (e.g.
virtual OFCondition | copyFrom (const DcmObject &rhs)
| virtual object copying.
virtual OFCondition | setVR (DcmEVR vr)
| set/change the current value representation of the uncompressed image representation, if any
virtual DcmEVR | ident () const
| return identifier for this class.
virtual void | print (STD_NAMESPACE ostream &out, const size_t flags=0, const int level=0, const char *pixelFileName=NULL, size_t *pixelCounter=NULL)
| print all elements of the item to a stream
virtual OFBool | canWriteXfer (const E_TransferSyntax newXfer, const E_TransferSyntax oldXfer)
| tests if it is possible to write a specific representation Only existing representations are considered, since this method does not create a representation.
virtual Uint32 | calcElementLength (const E_TransferSyntax xfer, const E_EncodingType enctype)
| calculate the length of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences.
virtual Uint32 | getLength (const E_TransferSyntax xfer=EXS_LittleEndianImplicit, const E_EncodingType enctype=EET_UndefinedLength)
| returns length of representation conforming to the transfer syntax
virtual void | transferInit ()
| initialize the transfer state of this object.
virtual OFCondition | read (DcmInputStream &inStream, const E_TransferSyntax ixfer, const E_GrpLenEncoding glenc=EGL_noChange, const Uint32 maxReadLength=DCM_MaxReadLength)
| This function reads the data value of a pixel data attribute which is captured in the input stream and captures this information in this.
virtual OFCondition | write (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| writes a representation conforming to the transfer syntax It does not create a representation.
virtual OFCondition | writeXML (STD_NAMESPACE ostream &out, const size_t flags=0)
| write object in XML format
virtual OFCondition | writeJson (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write object in JSON format to a stream
virtual OFCondition | writeSignatureFormat (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| special write method for creation of digital signatures
virtual OFCondition | loadAllDataIntoMemory (void)
| this method loads all attribute values maintained by this object and all sub-objects (in case of a container such as DcmDataset) into memory.
virtual void | transferEnd ()
| finalize the transfer state of this object.
OFBool | canChooseRepresentation (const E_TransferSyntax repType, const DcmRepresentationParameter *repParam)
| test if it is possible to choose the representation in the parameters
OFCondition | chooseRepresentation (const E_TransferSyntax repType, const DcmRepresentationParameter *repParam, DcmStack &stack)
| choose a specific representation.
void | putOriginalRepresentation (const E_TransferSyntax repType, const DcmRepresentationParameter *repParam, DcmPixelSequence *pixSeq)
| Inserts an original encapsulated representation.
virtual OFCondition | putUint8Array (const Uint8 *byteValue, const unsigned long length)
| insert an original unencapsulated representation.
virtual OFCondition | putUint16Array (const Uint16 *wordValue, const unsigned long length)
| insert an original unencapsulated representation.
virtual OFCondition | createUint8Array (const Uint32 numBytes, Uint8 *&bytes)
| create an empty Uint8 array of given number of bytes and set it.
virtual OFCondition | createUint16Array (const Uint32 numWords, Uint16 *&words)
| create an empty Uint16 array of given number of words and set it.
virtual OFCondition | createValueFromTempFile (DcmInputStreamFactory *factory, const Uint32 length, const E_ByteOrder byteOrder)
| replace the attribute value with the content of the given temporary file.
OFCondition | getEncapsulatedRepresentation (const E_TransferSyntax repType, const DcmRepresentationParameter *repParam, DcmPixelSequence *&pixSeq)
| get a specific existing Representation, creates no representation if repParam is NULL, then the representation conforming to the default representationParameters (defined with the codec) is returned.
void | getOriginalRepresentationKey (E_TransferSyntax &repType, const DcmRepresentationParameter *&repParam)
| returns the representation identification (key) consisting of representation type and parameter of the original representation
void | getCurrentRepresentationKey (E_TransferSyntax &repType, const DcmRepresentationParameter *&repParam)
| returns the representation identification (key) consisting of representation type and parameter of the current representation
OFCondition | setCurrentRepresentationParameter (const DcmRepresentationParameter *repParam)
| sets the representation identification parameter of the current representation
OFBool | hasRepresentation (const E_TransferSyntax repType, const DcmRepresentationParameter *repParam=NULL)
| checks if a specific conforming representation exists.
OFCondition | removeRepresentation (const E_TransferSyntax repType, const DcmRepresentationParameter *repParam)
| deletes a representation.
void | removeAllButOriginalRepresentations ()
| removes all but the original representation
void | removeAllButCurrentRepresentations ()
| removes all but the current representation.
OFCondition | removeOriginalRepresentation (const E_TransferSyntax repType, const DcmRepresentationParameter *repParam)
| delete original representation and set new original representation.
void | setNonEncapsulationFlag (OFBool flag)
| set or clear the flag that indicates that this pixel data element will be written in uncompressed (defined length) format even if the dataset itself is written in a compressed syntax where pixel data is normally written in encapsulated (undefined length) format.
virtual OFCondition | getUncompressedFrame (DcmItem *dataset, Uint32 frameNo, Uint32 &startFragment, void *buffer, Uint32 bufSize, OFString &decompressedColorModel, DcmFileCache *cache=NULL)
| access single frame without decompressing or loading a complete multi-frame object.
virtual OFCondition | getDecompressedColorModel (DcmItem *dataset, OFString &decompressedColorModel)
| determine color model of the decompressed image
Public Member Functions inherited from DcmPolymorphOBOW
| DcmPolymorphOBOW (const DcmTag &tag, const Uint32 len=0)
| constructor
| DcmPolymorphOBOW (const DcmPolymorphOBOW &old)
| copy constructor
virtual | ~DcmPolymorphOBOW ()
| destructor
DcmPolymorphOBOW & | operator= (const DcmPolymorphOBOW &obj)
| copy assignment operator
virtual OFCondition | getUint8Array (Uint8 *&val)
| get a pointer to the element value of the current element as type string.
virtual OFCondition | getUint16Array (Uint16 *&val)
| get a pointer to the element value of the current element as type Uint16.
Public Member Functions inherited from DcmOtherByteOtherWord
| DcmOtherByteOtherWord (const DcmTag &tag)
| constructor.
| DcmOtherByteOtherWord (const DcmOtherByteOtherWord &old)
| copy constructor
virtual | ~DcmOtherByteOtherWord ()
| destructor
DcmOtherByteOtherWord & | operator= (const DcmOtherByteOtherWord &obj)
| assignment operator
virtual OFCondition | checkValue (const OFString &vm="", const OFBool oldFormat=OFFalse)
| check whether stored value conforms to the VR and to the specified VM
virtual unsigned long | getVM ()
| get value multiplicity
virtual unsigned long | getNumberOfValues ()
| get number of values stored in this element
virtual OFCondition | getUint8 (Uint8 &byteVal, const unsigned long pos=0)
| get particular 8 bit value.
virtual OFCondition | getUint16 (Uint16 &wordVal, const unsigned long pos=0)
| get particular 16 bit value.
virtual OFCondition | getOFString (OFString &stringVal, const unsigned long pos, OFBool normalize=OFTrue)
| get a particular value as a character string.
virtual OFCondition | getOFStringArray (OFString &stringVal, OFBool normalize=OFTrue)
| get element value as a character string.
virtual OFCondition | putString (const char *stringVal)
| set element value from the given character string.
virtual OFCondition | putString (const char *stringVal, const Uint32 stringLen)
| set element value from the given character string.
virtual OFCondition | verify (const OFBool autocorrect=OFFalse)
| check the currently stored element value
Public Member Functions inherited from DcmElement
| DcmElement (const DcmTag &tag, const Uint32 len=0)
| constructor.
| DcmElement (const DcmElement &old)
| copy constructor
virtual | ~DcmElement ()
| destructor
DcmElement & | operator= (const DcmElement &obj)
| assignment operator
virtual OFBool | isLeaf () const
| check if this element is a leaf node in a dataset tree.
virtual OFBool | isElement () const
| check if this element can be safely casted to DcmElement
OFBool | valueLoaded () const
| check if value of this element is loaded into main memory
virtual OFCondition | clear ()
| clear (remove) attribute value
virtual OFCondition | getSint16 (Sint16 &val, const unsigned long pos=0)
| retrieve a single value of type Sint16.
virtual OFCondition | getSint32 (Sint32 &val, const unsigned long pos=0)
| retrieve a single value of type Sint32.
virtual OFCondition | getUint32 (Uint32 &val, const unsigned long pos=0)
| retrieve a single value of type Uint32.
virtual OFCondition | getFloat32 (Float32 &val, const unsigned long pos=0)
| retrieve a single value of type Float32.
virtual OFCondition | getSint64 (Sint64 &val, const unsigned long pos=0)
| retrieve a single value of type Sint64.
virtual OFCondition | getUint64 (Uint64 &val, const unsigned long pos=0)
| retrieve a single value of type Uint64.
virtual OFCondition | getFloat64 (Float64 &val, const unsigned long pos=0)
| retrieve a single value of type Float64.
virtual OFCondition | getTagVal (DcmTagKey &val, const unsigned long pos=0)
| retrieve a single value of type DcmTagKey.
virtual OFCondition | getString (char *&val)
| get a pointer to the element value of the current element as type string.
virtual OFCondition | getString (char *&val, Uint32 &len)
| get a pointer to the element value of the current element as type string.
virtual OFCondition | getSint16Array (Sint16 *&val)
| get a pointer to the element value of the current element as type Sint16.
virtual OFCondition | getSint32Array (Sint32 *&val)
| get a pointer to the element value of the current element as type Sint32.
virtual OFCondition | getUint32Array (Uint32 *&val)
| get a pointer to the element value of the current element as type Uint32.
virtual OFCondition | getFloat32Array (Float32 *&val)
| get a pointer to the element value of the current element as type Float32.
virtual OFCondition | getSint64Array (Sint64 *&val)
| get a pointer to the element value of the current element as type Sint64.
virtual OFCondition | getUint64Array (Uint64 *&val)
| get a pointer to the element value of the current element as type Uint64.
virtual OFCondition | getFloat64Array (Float64 *&val)
| get a pointer to the element value of the current element as type Float64.
OFCondition | detachValueField (OFBool copy=OFFalse)
| detach the value field from the DICOM element (i.e., this object).
virtual OFCondition | putOFStringArray (const OFString &val)
| replace the element value by a copy of the given string (which is possibly multi-valued).
virtual OFCondition | putSint16 (const Sint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint16 value.
virtual OFCondition | putUint16 (const Uint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint16 value.
virtual OFCondition | putSint32 (const Sint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint32 value.
virtual OFCondition | putUint32 (const Uint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint32 value.
virtual OFCondition | putFloat32 (const Float32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float32 value.
virtual OFCondition | putFloat64 (const Float64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float64 value.
virtual OFCondition | putTagVal (const DcmTagKey &attrTag, const unsigned long pos=0)
| insert into the element value a copy of the given DcmTagKey value.
virtual OFCondition | putSint16Array (const Sint16 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint16 array (which is possibly multi-valued).
virtual OFCondition | putSint32Array (const Sint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint32 array (which is possibly multi-valued).
virtual OFCondition | putUint32Array (const Uint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint32 array (which is possibly multi-valued).
virtual OFCondition | putFloat32Array (const Float32 *vals, const unsigned long num)
| replace the element value by a copy of the given Float32 array (which is possibly multi-valued).
virtual OFCondition | putFloat64Array (const Float64 *vals, const unsigned long num)
| replace the element value by a copy of the given Float64 array (which is possibly multi-valued).
virtual OFCondition | getPartialValue (void *targetBuffer, const Uint32 offset, Uint32 numBytes, DcmFileCache *cache=NULL, E_ByteOrder byteOrder=gLocalByteOrder)
| Copy numBytes bytes of data from the attribute value in byteOrder byte order to targetBuffer, starting at byte offset offset of the attribute value.
virtual void | compact ()
| remove the attribute value from memory if the attribute value can be loaded from file when needed again.
virtual OFCondition | getUncompressedFrameSize (DcmItem *dataset, Uint32 &frameSize, OFBool pixelDataIsUncompressed) const
| compute uncompressed frame size of a single frame of this image.
virtual OFBool | isUniversalMatch (const OFBool normalize=OFTrue, const OFBool enableWildCardMatching=OFTrue)
| Determine if this element is universal matching.
virtual OFBool | matches (const DcmElement &candidate, const OFBool enableWildCardMatching=OFTrue) const
| perform attribute matching.
virtual OFBool | combinationMatches (const DcmElement &keySecond, const DcmElement &candidateFirst, const DcmElement &candidateSecond) const
| perform combined attribute matching.
const DcmInputStreamFactory * | getInputStream () const
| returns a pointer to the input stream, if available, NULL otherwise.
Public Member Functions inherited from DcmObject
| DcmObject (const DcmTag &tag, const Uint32 len=0)
| constructor.
| DcmObject (const DcmObject &obj)
| copy constructor
virtual | ~DcmObject ()
| destructor
DcmObject & | operator= (const DcmObject &obj)
| copy assignment operator
DcmEVR | getVR () const
| return the value representation assigned to this object.
OFBool | isaString () const
| check if this element is a string type, based on the VR.
virtual OFBool | isNested () const
| check if this element is nested in a sequence of items, i.e. not a top-level or stand-alone element
E_TransferState | transferState () const
| return the current transfer (read/write) state of this object.
DcmItem * | getRootItem ()
| get root dataset/item (top-level) that contains this object.
virtual DcmItem * | getParentItem ()
| get parent item of this object.
DcmObject * | getParent ()
| get parent of this object.
const DcmObject * | getParent () const
| get parent of this object.
void | setParent (DcmObject *parent)
| set parent of this object.
Uint16 | getGTag () const
| return the group number of the attribute tag for this object
Uint16 | getETag () const
| return the element number of the attribute tag for this object
const DcmTag & | getTag () const
| return const reference to the attribute tag for this object
void | setGTag (Uint16 gtag)
| assign group tag (but not element tag) of the attribute tag for this object.
virtual OFBool | isSignable () const
| returns true if the current object may be included in a digital signature
virtual OFBool | containsUnknownVR () const
| returns true if the object contains an element with Unknown VR at any nesting level
virtual OFBool | containsExtendedCharacters (const OFBool checkAllStrings=OFFalse)
| check if this object contains non-ASCII characters
virtual OFBool | isAffectedBySpecificCharacterSet () const
| check if this object is affected by SpecificCharacterSet
virtual OFCondition | convertCharacterSet (DcmSpecificCharacterSet &converter)
| convert this object from the currently selected source character set to the currently selected destination character set (if affected by SpecificCharacterSet)
virtual OFBool | isEmpty (const OFBool normalize=OFTrue)
| check if this object is empty
virtual DcmObject * | nextInContainer (const DcmObject *obj)
| this method is only used in container classes derived from this class, that is, DcmItem and DcmSequenceOfItems.
virtual OFCondition | nextObject (DcmStack &stack, const OFBool intoSub)
| this method enables a stack based, depth-first traversal of a complete hierarchical DICOM dataset (that is, classes derived from DcmItem or DcmSequenceOfItems).
virtual OFCondition | search (const DcmTagKey &xtag, DcmStack &resultStack, E_SearchMode mode=ESM_fromHere, OFBool searchIntoSub=OFTrue)
| a complex, stack-based, hierarchical search method.
Uint32 | getLengthField () const
| return the current value of the Length field (which is different from the functionality of the public getLength() method).

## Private Member Functions
OFBool | writeUnencapsulated (const E_TransferSyntax xfer)
| check if this element should be written unencapsulated, even though an encapsulated transfer syntax is used.
void | clearRepresentationList (DcmRepresentationListIterator leaveInList)
| This function removes all pixel representations from the list of pixel representations except the one which was passed.
OFCondition | findConformingEncapsulatedRepresentation (const DcmXfer &repType, const DcmRepresentationParameter *repParam, DcmRepresentationListIterator &result)
| find a conforming representation in the list of encapsulated representations
OFCondition | findRepresentationEntry (const DcmRepresentationEntry &findEntry, DcmRepresentationListIterator &result)
| find a representation entry and return an iterator to the found entry or the next element in the list.
DcmRepresentationListIterator | insertRepresentationEntry (DcmRepresentationEntry *repEntry)
| insert or replace a representation entry in the list
OFCondition | decode (const DcmXfer &fromType, const DcmRepresentationParameter *fromParam, DcmPixelSequence *fromPixSeq, DcmStack &pixelStack)
| decode representation to unencapsulated format
OFCondition | encode (const DcmXfer &fromType, const DcmRepresentationParameter *fromParam, DcmPixelSequence *fromPixSeq, const DcmXfer &toType, const DcmRepresentationParameter *toParam, DcmStack &pixelStack)
| encode to encapsulated format
void | recalcVR ()
| set the current VR, which is always OB if the currently selected pixel representation is compressed, and may be OB or OW for uncompressed.

## Private Attributes
DcmRepresentationList | repList
| List of representations of pixel data.
DcmRepresentationListIterator | repListEnd
| Iterator to the last dummy element in representation list.
DcmRepresentationListIterator | original
| Iterator to the original representation.
DcmRepresentationListIterator | current
| current list element for some operations
OFBool | existUnencapsulated
| shows if an unencapsulated representation is stored
OFBool | alwaysUnencapsulated
| this flag indicates that this pixel data element will be written in uncompressed (defined length) format even if the dataset itself is written in a compressed syntax where pixel data is normally written in encapsulated (undefined length) format.
DcmEVR | unencapsulatedVR
| value representation of unencapsulated data
DcmPixelSequence * | pixelSeqForWrite
| in write function: pointer to current pixel sequence

## Friends
class | DcmRepresentationEntry

## Additional Inherited Members
Static Public Member Functions inherited from DcmElement
static int | scanValue (const OFString &value, const OFString &vr, const size_t pos=0, const size_t num=OFString_npos)
| scan string value for conformance with given value representation (VR)
static int | scanValue (const OFString &vr, const char *const value, const size_t size)
| scan string value for conformance with given value representation (VR)
static unsigned long | determineVM (const char *str, const size_t len)
| determine the number of values stored in a string, i.e. the value multiplicity (VM)
static size_t | getValueFromString (const char *str, const size_t pos, const size_t len, OFString &val)
| get the first value stored in the given string.
static OFCondition | checkVM (const unsigned long vmNum, const OFString &vmStr)
| check for correct value multiplicity (VM)
Protected Member Functions inherited from DcmOtherByteOtherWord
| DcmOtherByteOtherWord (const DcmTag &tag, const Uint32 len)
| constructor.
virtual void | postLoadValue ()
| method is called after the element value has been loaded.
OFCondition | alignValue ()
| align the element value to an even length (padding)
void | printPixel (STD_NAMESPACE ostream &out, const size_t flags, const int level, const char *pixelFileName, size_t *pixelCounter)
| print pixel data and optionally write it to a binary file.
Protected Member Functions inherited from DcmElement
void * | getValue (const E_ByteOrder newByteOrder=gLocalByteOrder)
| This function returns this element's value.
OFCondition | changeValue (const void *value, const Uint32 position, const Uint32 num)
| insert into the element value a copy of the given raw value.
OFCondition | putValue (const void *value, const Uint32 length)
| replace the element value by a copy of the given raw data block
OFCondition | createEmptyValue (const Uint32 length)
| create a new, empty value field of given size.
OFCondition | loadValue (DcmInputStream *inStream=NULL)
| This function reads the data value of an attribute and stores the information which was read in this.
virtual Uint8 * | newValueField ()
| This function creates a byte array of Length bytes and returns this array.
void | swapValueField (size_t valueWidth)
| swaps the content of the value field (if loaded) from big-endian to little-endian or back
virtual void | writeXMLStartTag (STD_NAMESPACE ostream &out, const size_t flags, const char *attrText=NULL)
| write element start tag in XML format
virtual void | writeXMLEndTag (STD_NAMESPACE ostream &out, const size_t flags)
| write element end tag in XML format
virtual void | writeJsonOpener (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element start tag in JSON format
virtual void | writeJsonCloser (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element end tag in JSON format
E_ByteOrder | getByteOrder () const
| return the current byte order of the value field
void | setByteOrder (E_ByteOrder val)
| set the current byte order of the value field
Protected Member Functions inherited from DcmObject
void | printNestingLevel (STD_NAMESPACE ostream &out, const size_t flags, const int level)
| print line indentation, e.g. a couple of spaces for each nesting level.
void | printInfoLineStart (STD_NAMESPACE ostream &out, const size_t flags, const int level, DcmTag *tag=NULL)
| print beginning of the info line.
void | printInfoLineEnd (STD_NAMESPACE ostream &out, const size_t flags, const unsigned long printedLength=0xffffffff, DcmTag *tag=NULL)
| print end of the info line.
virtual void | printInfoLine (STD_NAMESPACE ostream &out, const size_t flags, const int level=0, const char *info=NULL, DcmTag *tag=NULL, const OFBool isInfo=OFTrue)
| print given text with element information.
virtual OFCondition | writeTagAndLength (DcmOutputStream &outStream, const E_TransferSyntax oxfer, Uint32 &writtenBytes) const
| write tag, VR and length field to the given output stream
virtual Uint32 | getTagAndLengthSize (const E_TransferSyntax oxfer) const
| return the number of bytes needed to serialize the tag, VR and length information of the current object using the given transfer syntax.
const char * | getTagName ()
| return the DICOM attribute tag name for this object.
void | setTagVR (DcmEVR vr)
| set the VR for this attribute
E_TransferState | getTransferState () const
| return the current transfer state of this object during serialization/deserialization
void | setTransferState (E_TransferState newState)
| set the current transfer state of this object during serialization/deserialization
Uint32 | getTransferredBytes () const
| return the number of transferred bytes for this object during serialization/deserialization
void | setTransferredBytes (Uint32 val)
| set the number of transferred bytes for this object during serialization/deserialization
void | incTransferredBytes (Uint32 val)
| add to the number of transferred bytes for this object during serialization/deserialization
void | setLengthField (Uint32 val)
| set the current value of the Length field
Static Protected Member Functions inherited from DcmObject
static OFCondition | writeTag (DcmOutputStream &outStream, const DcmTag &tag, const E_TransferSyntax oxfer)
| static helper function that writes a given attribute tag to a binary output stream using the byte order indicated by the transfer syntax.
Protected Attributes inherited from DcmObject
OFCondition | errorFlag
| error flag for this object.

## Detailed Description

The class DcmPixelData stores different pixel representations identified by a type (the transfer syntax) and some representation parameters The three unencapsulated transfer syntaxes belong to the same pixel representation.

A type (or transfer syntax) conforms to a representation if the type and the representation type are equal or both are unencapsulated. If this is valid for the representation read or set by chooseRepresentation then this representation is the conforming representation. else a representation with the default parameter set defined in the codec is the conforming representation.

## Constructor & Destructor Documentation

## ◆ DcmPixelData() [1/2]

DcmPixelData::DcmPixelData | ( | const DcmTag & | tag,
|  | const Uint32 | len = 0 )

constructor.

Create new element from given tag and length.

Parameters

  tag | attribute tag
  len | length of the attribute value

Referenced by DcmPixelData(), clone(), and operator=().

## ◆ DcmPixelData() [2/2]

DcmPixelData::DcmPixelData | ( | const DcmPixelData & | pixelData | ) |

copy constructor

Parameters

  pixelData | element to be copied

References DcmPixelData().

## Member Function Documentation

## ◆ calcElementLength()

virtual Uint32 DcmPixelData::calcElementLength | ( | const E_TransferSyntax | xfer,
|  | const E_EncodingType | enctype )
| virtual

calculate the length of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences.

For elements, the length includes the length of the tag, length field, VR field and the value itself, for items and sequences it returns the length of the complete item or sequence including delimitation tags if applicable.

Warning
  Since calcElementLength() returns a 32 bit integer, an overflow during calculation is possible for some derived classes that actually represent a compound value (e.g. items like DcmPixelItem). Such overflows will be detected, in which case the maximum possible value will be returned instead, coinciding with DCM_UndefinedLength.
  The implementation in DcmPixelData may return zero if no conforming representation exists and set the EC_RepresentationNotFound error flag to indicated it.
  When calculation the length of a sequence or an item containing multiple attributes, the implementation may return DCM_UndefinedLength to indicate a value that can not be encoded as a 32 bit length field. It will even do so if "dcmWriteOversizedSeqsAndItemsUndefined" is disabled, but then also set the EC_SeqOrItemContentOverflow error flag (inside getLength()) to indicated it.

Note
  Just check for zero or DCM_UndefinedLength return value and then have a look at the error flag in either case.

Parameters

  xfer | transfer syntax for length calculation
  enctype | sequence encoding type for length calculation

Returns
  length of DICOM element

Reimplemented from DcmElement.

## ◆ canChooseRepresentation()

OFBool DcmPixelData::canChooseRepresentation | ( | const E_TransferSyntax | repType,
|  | const DcmRepresentationParameter * | repParam )

test if it is possible to choose the representation in the parameters

Parameters

  repType | the representation type
  repParam | the representation parameters

## ◆ canWriteXfer()

virtual OFBool DcmPixelData::canWriteXfer | ( | const E_TransferSyntax | newXfer,
|  | const E_TransferSyntax | oldXfer )
| virtual

tests if it is possible to write a specific representation Only existing representations are considered, since this method does not create a representation.

Parameters

  newXfer | the syntax to be checked

Reimplemented from DcmOtherByteOtherWord.

Referenced by DiInputPixelTemplate< T1, T2 >::convert().

## ◆ chooseRepresentation()

OFCondition DcmPixelData::chooseRepresentation | ( | const E_TransferSyntax | repType,
|  | const DcmRepresentationParameter * | repParam,
|  | DcmStack & | stack )

choose a specific representation.

Remarks
  if representation does not exist it is created (if possible). if repParam is zero, a representation is chosen or created that is equal to the default representation parameters

Deprecated
  The direct call of this method by user code is deprecated. Use DcmDataset::chooseRepresentation() instead.

@repType the representation type @repParam the representation parameters @stack the object stack

## ◆ clearRepresentationList()

void DcmPixelData::clearRepresentationList | ( | DcmRepresentationListIterator | leaveInList | ) |
| private

This function removes all pixel representations from the list of pixel representations except the one which was passed.

Note that if parameter leaveInList equals repListEnd, all representations will be removed from the list.

Parameters

  leaveInList | Iterator to a representation which shall not be removed from the list of representations.

## ◆ clone()

virtual DcmObject * DcmPixelData::clone | ( |  | ) | const
| inlinevirtual

clone method

Returns
  deep copy of this object

Reimplemented from DcmPolymorphOBOW.

References DcmPixelData().

## ◆ compare()

virtual int DcmPixelData::compare | ( | const DcmElement & | rhs | ) | const
| virtual

comparison operator that compares the value of this element with a given element of the same type (e.g.

an DcmPixelData with a DcmPixelData). The tag of the element is also considered as the first component that is compared, followed by the object types (VR, i.e. DCMTK'S EVR). The DcmPixelData implementation checks whether the uncompressed data of both objects are identical, and if not provided, if the compressed data of both objects is the same, by comparing the pixel items bytewise.

Parameters

  rhs | the right hand side of the comparison

Returns
  0 if the object values are equal. -1 is returned if rhs is considered greater than this object. 1 is returned if rhs is considered smaller than this object.

Reimplemented from DcmPolymorphOBOW.

References DcmElement::DcmElement().

## ◆ copyFrom()

virtual OFCondition DcmPixelData::copyFrom | ( | const DcmObject & | rhs | ) |
| virtual

virtual object copying.

This method can be used for DcmObject and derived classes to get a deep copy of an object. Internally the assignment operator is called if the given DcmObject parameter is of the same type as "this" object instance. If not, an error is returned. This function permits copying an object by value in a virtual way which therefore is different to just calling the assignment operator of DcmElement which could result in slicing the object.

Parameters

  rhs | - [in] The instance to copy from. Has to be of the same class type as "this" object

Returns
  EC_Normal if copying was successful, error otherwise

Reimplemented from DcmPolymorphOBOW.

## ◆ createUint16Array()

virtual OFCondition DcmPixelData::createUint16Array | ( | const Uint32 | numWords,
|  | Uint16 *& | words )
| virtual

create an empty Uint16 array of given number of words and set it.

All array elements are initialized with a value of 0 (using 'memset'). This method is only applicable to OW data.

Parameters

  numWords | number of words (16 bit) to be created
  words | stores the pointer to the resulting buffer

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmPolymorphOBOW.

## ◆ createUint8Array()

virtual OFCondition DcmPixelData::createUint8Array | ( | const Uint32 | numBytes,
|  | Uint8 *& | bytes )
| virtual

create an empty Uint8 array of given number of bytes and set it.

All array elements are initialized with a value of 0 (using 'memset'). This method is only applicable to certain VRs, e.g. OB.

Parameters

  numBytes | number of bytes (8 bit) to be created
  bytes | stores the pointer to the resulting buffer

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmPolymorphOBOW.

## ◆ createValueFromTempFile()

virtual OFCondition DcmPixelData::createValueFromTempFile | ( | DcmInputStreamFactory * | factory,
|  | const Uint32 | length,
|  | const E_ByteOrder | byteOrder )
| virtual

replace the attribute value with the content of the given temporary file.

The temporary file is not opened/loaded until the attribute value is accessed, very much like large attributes that remain in file during a read operation.

Parameters

  factory | a factory object that is able to create an input stream to the temporary file at the right location.
  length | attribute value length, in bytes. Must be even length. The length is not checked against the real length of the temporary file, which might be written or completed after the call to this method.
  byteOrder | byte order in the temporary file

Returns
  EC_Normal upon success, an error code otherwise.

Reimplemented from DcmElement.

## ◆ decode()

OFCondition DcmPixelData::decode | ( | const DcmXfer & | fromType,
|  | const DcmRepresentationParameter * | fromParam,
|  | DcmPixelSequence * | fromPixSeq,
|  | DcmStack & | pixelStack )
| private

decode representation to unencapsulated format

Parameters

  fromType | transfer syntax to decode from
  fromParam | representation parameter of current compressed representation, may be NULL.
  fromPixSeq | compressed pixel sequence
  pixelStack | stack pointing to the location of the pixel data element in the current dataset.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ encode()

OFCondition DcmPixelData::encode | ( | const DcmXfer & | fromType,
|  | const DcmRepresentationParameter * | fromParam,
|  | DcmPixelSequence * | fromPixSeq,
|  | const DcmXfer & | toType,
|  | const DcmRepresentationParameter * | toParam,
|  | DcmStack & | pixelStack )
| private

encode to encapsulated format

Parameters

  fromType | current transfer syntax of the compressed image
  fromParam | current representation parameter of compressed data, may be NULL
  fromPixSeq | compressed pixel sequence
  toType | transfer syntax to compress to
  toParam | representation parameter describing the desired new compressed representation (e.g. JPEG quality)
  pixelStack | stack pointing to the location of the pixel data element in the current dataset.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ findRepresentationEntry()

OFCondition DcmPixelData::findRepresentationEntry | ( | const DcmRepresentationEntry & | findEntry,
|  | DcmRepresentationListIterator & | result )
| private

find a representation entry and return an iterator to the found entry or the next element in the list.

The condition returned can be EC_Normal if such an entry is found or EC_RepresentationNotFound. The pixSeq attribute in findEntry can be NULL, it is not needed for the find operation!

Parameters

  findEntry | the entry to find
  result | the found entry

Returns
  EC_Normal if entry is found, EC_RepresentationNotFound otherwise.

## ◆ getCurrentRepresentationKey()

void DcmPixelData::getCurrentRepresentationKey | ( | E_TransferSyntax & | repType,
|  | const DcmRepresentationParameter *& | repParam )

returns the representation identification (key) consisting of representation type and parameter of the current representation

Parameters

  repType | the transfer Syntax
  repParam | the DcmRepresentationParameter

## ◆ getDecompressedColorModel()

virtual OFCondition DcmPixelData::getDecompressedColorModel | ( | DcmItem * | dataset,
|  | OFString & | decompressedColorModel )
| virtual

determine color model of the decompressed image

Parameters

  dataset | pointer to DICOM dataset in which this pixel data object is located. Used to access photometric interpretation.
  decompressedColorModel | upon successful return, the color model of the decompressed image (which may be different from the one used in the compressed images) is returned in this parameter

Returns
  EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## ◆ getEncapsulatedRepresentation()

OFCondition DcmPixelData::getEncapsulatedRepresentation | ( | const E_TransferSyntax | repType,
|  | const DcmRepresentationParameter * | repParam,
|  | DcmPixelSequence *& | pixSeq )

get a specific existing Representation, creates no representation if repParam is NULL, then the representation conforming to the default representationParameters (defined with the codec) is returned.

Parameters

  repType | the transfer syntax
  repParam | representation parameters
  pixSeq | the found representation

## ◆ getLength()

virtual Uint32 DcmPixelData::getLength | ( | const E_TransferSyntax | xfer = EXS_LittleEndianImplicit,
|  | const E_EncodingType | enctype = EET_UndefinedLength )
| virtual

returns length of representation conforming to the transfer syntax

Parameters

  xfer | the transfer syntax
  enctype | the encoding type

Returns
  returns length of representation value field conforming to given transfer syntax. It does not create a representation. If no conforming representation exists, an error code is set and 0 returned.

Reimplemented from DcmElement.

References EET_UndefinedLength, and EXS_LittleEndianImplicit.

## ◆ getOriginalRepresentationKey()

void DcmPixelData::getOriginalRepresentationKey | ( | E_TransferSyntax & | repType,
|  | const DcmRepresentationParameter *& | repParam )

returns the representation identification (key) consisting of representation type and parameter of the original representation

Parameters

  repType | the transfer syntax
  the | representations parameters

## ◆ getUncompressedFrame()

virtual OFCondition DcmPixelData::getUncompressedFrame | ( | DcmItem * | dataset,
|  | Uint32 | frameNo,
|  | Uint32 & | startFragment,
|  | void * | buffer,
|  | Uint32 | bufSize,
|  | OFString & | decompressedColorModel,
|  | DcmFileCache * | cache = NULL )
| virtual

access single frame without decompressing or loading a complete multi-frame object.

The frame is copied into the buffer passed by the caller which must be large enough to contain a complete frame.

Parameters

  dataset | pointer to DICOM dataset in which this pixel data object is located. Used to access rows, columns, samples per pixel etc.
  frameNo | number of frame, starting with 0 for the first frame.
  startFragment | index of the compressed fragment that contains all or the first part of the compressed bitstream for the given frameNo. Upon successful return this parameter is updated to contain the index of the first compressed fragment of the next frame. When unknown, zero should be passed. In this case the decompression algorithm will try to determine the index by itself, which will always work if frames are decompressed in increasing order from first to last, but may fail if frames are decompressed in random order, multiple fragments per frame and multiple frames are present in the dataset, and the offset table is empty.
  buffer | pointer to buffer allocated by the caller. The buffer must be large enough for one frame of this image.
  bufSize | size of buffer, in bytes. This number must be even so that the data can properly be converted to a different endianness.
  decompressedColorModel | upon successful return, the color model of the decompressed image (which may be different from the one used in the compressed images) is returned in this parameter.
  cache | file cache object that may be passed to multiple subsequent calls to this method for the same file; the file cache will then keep a file handle open, thus improving performance. Optional, may be NULL

Returns
  EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Referenced by DiInputPixelTemplate< T1, T2 >::convert().

## ◆ hasRepresentation()

OFBool DcmPixelData::hasRepresentation | ( | const E_TransferSyntax | repType,
|  | const DcmRepresentationParameter * | repParam = NULL )

checks if a specific conforming representation exists.

Parameters

  repType | the representation Type
  repParam | the representation Parameter

Returns
  OFTrue if a specific conforming representation exists, OFFalse otherwise

## ◆ ident()

virtual DcmEVR DcmPixelData::ident | ( | void |  | ) | const
| inlinevirtual

return identifier for this class.

Every class derived from this class returns a unique value of type enum DcmEVR for this call. This is used as a "poor man's RTTI" to correctly identify instances derived from this class even on compilers not supporting RTTI.

Returns
  type identifier of this class

Reimplemented from DcmOtherByteOtherWord.

References EVR_PixelData.

## ◆ insertRepresentationEntry()

DcmRepresentationListIterator DcmPixelData::insertRepresentationEntry | ( | DcmRepresentationEntry * | repEntry | ) |
| private

insert or replace a representation entry in the list

Parameters

  repEntry | the DcmRepresentationEntry to be inserted

Returns
  the inserted entry

## ◆ loadAllDataIntoMemory()

virtual OFCondition DcmPixelData::loadAllDataIntoMemory | ( | void |  | ) |
| virtual

this method loads all attribute values maintained by this object and all sub-objects (in case of a container such as DcmDataset) into memory.

After a call to this method, the file from which a dataset was read may safely be deleted or replaced. For large files, this method may obviously allocate large amounts of memory.

Returns
  EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## ◆ operator=()

DcmPixelData & DcmPixelData::operator= | ( | const DcmPixelData & | obj | ) |

copy assignment operator

Parameters

  obj | element to be copied

References DcmPixelData().

## ◆ print()

virtual void DcmPixelData::print | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags = 0,
|  | const int | level = 0,
|  | const char * | pixelFileName = NULL,
|  | size_t * | pixelCounter = NULL )
| virtual

print all elements of the item to a stream

Parameters

  out | output stream
  flags | optional flag used to customize the output (see DCMTypes::PF_xxx)
  level | current level of nested items. Used for indentation.
  pixelFileName | optional filename used to write the raw pixel data file
  pixelCounter | optional counter used for automatic pixel data filename creation

Reimplemented from DcmOtherByteOtherWord.

## ◆ putOriginalRepresentation()

void DcmPixelData::putOriginalRepresentation | ( | const E_TransferSyntax | repType,
|  | const DcmRepresentationParameter * | repParam,
|  | DcmPixelSequence * | pixSeq )

Inserts an original encapsulated representation.

Remarks
  current and original representations are changed, all old representations are deleted

Parameters

  repType | the representation type
  repParam | the representation parameters
  pixSeq | the pixel sequence

## ◆ putUint16Array()

virtual OFCondition DcmPixelData::putUint16Array | ( | const Uint16 * | wordValue,
|  | const unsigned long | length )
| virtual

insert an original unencapsulated representation.

Remarks
  current and original representations are changed, all old representations are deleted. The array data is copied.

Parameters

  wordValue | new attribute value
  length | number of values in array vals

Reimplemented from DcmPolymorphOBOW.

## ◆ putUint8Array()

virtual OFCondition DcmPixelData::putUint8Array | ( | const Uint8 * | byteValue,
|  | const unsigned long | length )
| virtual

insert an original unencapsulated representation.

Remarks
  current and original representations are changed, all old representations are deleted. The array data is copied.

Parameters

  byteValue | used to check for corrupted data
  length | the length of the element to put

Reimplemented from DcmPolymorphOBOW.

## ◆ read()

virtual OFCondition DcmPixelData::read | ( | DcmInputStream & | inStream,
|  | const E_TransferSyntax | ixfer,
|  | const E_GrpLenEncoding | glenc = EGL_noChange,
|  | const Uint32 | maxReadLength = DCM_MaxReadLength )
| virtual

This function reads the data value of a pixel data attribute which is captured in the input stream and captures this information in this.

This function takes into account, if the pixel data is captured in native (uncompressed) or encapsulated (compressed) format.

Parameters

  inStream | The stream which contains the information.
  ixfer | The transfer syntax which was used to encode the information in inStream.
  glenc | Encoding type for group length; specifies what will be done with group length tags.
  maxReadLength | Maximum read length for reading an attribute value.

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmPolymorphOBOW.

References EGL_noChange.

## ◆ removeAllButCurrentRepresentations()

void DcmPixelData::removeAllButCurrentRepresentations | ( |  | ) |

removes all but the current representation.

Makes the current representation original.

## ◆ removeOriginalRepresentation()

OFCondition DcmPixelData::removeOriginalRepresentation | ( | const E_TransferSyntax | repType,
|  | const DcmRepresentationParameter * | repParam )

delete original representation and set new original representation.

If the new representation does not exist, the original one is not deleted and an error code returns

Parameters

  repType | the representation type
  repParam | the representation parameter

Returns
  EC_Normal on success, the error code otherwise

## ◆ removeRepresentation()

OFCondition DcmPixelData::removeRepresentation | ( | const E_TransferSyntax | repType,
|  | const DcmRepresentationParameter * | repParam )

deletes a representation.

Remarks
  It is not possible to delete the original representation with this method

Parameters

  repType | the representation Type
  repParam | the representation Parameter

Returns
  EC_NORMAL on success, the error otherwise

## ◆ setCurrentRepresentationParameter()

OFCondition DcmPixelData::setCurrentRepresentationParameter | ( | const DcmRepresentationParameter * | repParam | ) |

sets the representation identification parameter of the current representation

Parameters

  repParam | the representation Parameter

Returns
  EC_Normal on success, EC_RepresentationNotFound if the representation was not found

## ◆ setNonEncapsulationFlag()

void DcmPixelData::setNonEncapsulationFlag | ( | OFBool | flag | ) |

set or clear the flag that indicates that this pixel data element will be written in uncompressed (defined length) format even if the dataset itself is written in a compressed syntax where pixel data is normally written in encapsulated (undefined length) format.

By default this flag is false, unless the dataset was read in an encapsulated transfer syntax and this pixel data element was already present in uncompressed format. This flag should never be enabled for pixel data elements on the main dataset level, only for pixel data elements within the icon image sequence or some other "private" place.

Parameters

  flag | new value of flag

## ◆ setVR()

virtual OFCondition DcmPixelData::setVR | ( | DcmEVR | vr | ) |
| virtual

set/change the current value representation of the uncompressed image representation, if any

Parameters

  vr | new value representation to be set. All VRs except for OW (Other Word String) are treated as 8 bit data (OB). This is particularly useful for unknown (UN) or unsupported VRs.

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmOtherByteOtherWord.

## ◆ transferEnd()

virtual void DcmPixelData::transferEnd | ( |  | ) |
| virtual

finalize the transfer state of this object.

This method must be called when reading/writing this object from/to a stream has been completed.

Reimplemented from DcmPolymorphOBOW.

## ◆ transferInit()

virtual void DcmPixelData::transferInit | ( |  | ) |
| virtual

initialize the transfer state of this object.

This method must be called before this object is written to a stream or read (parsed) from a stream.

Reimplemented from DcmPolymorphOBOW.

## ◆ write()

virtual OFCondition DcmPixelData::write | ( | DcmOutputStream & | outStream,
|  | const E_TransferSyntax | oxfer,
|  | const E_EncodingType | enctype,
|  | DcmWriteCache * | wcache )
| virtual

writes a representation conforming to the transfer syntax It does not create a representation.

If no conforming representation exists, an error code is returned. The written representation is the new current representation

Parameters

  outStream | the output stream
  oxfer | the transfer syntax that should be used
  enctype | encoding types (undefined or explicit length)
  pointer | to write cache object, may be NULL

Returns
  EC_Normal on success, the error otherwise

Reimplemented from DcmPolymorphOBOW.

## ◆ writeJson()

virtual OFCondition DcmPixelData::writeJson | ( | STD_NAMESPACE ostream & | out,
|  | DcmJsonFormat & | format )
| virtual

write object in JSON format to a stream

Parameters

  out | output stream to which the JSON document is written
  format | used to format and customize the output

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmOtherByteOtherWord.

## ◆ writeSignatureFormat()

virtual OFCondition DcmPixelData::writeSignatureFormat | ( | DcmOutputStream & | outStream,
|  | const E_TransferSyntax | oxfer,
|  | const E_EncodingType | enctype,
|  | DcmWriteCache * | wcache )
| virtual

special write method for creation of digital signatures

Parameters

  outStream | DICOM output stream
  oxfer | output transfer syntax
  enctype | encoding types (undefined or explicit length)
  wcache | pointer to write cache object, may be NULL

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmPolymorphOBOW.

## ◆ writeUnencapsulated()

OFBool DcmPixelData::writeUnencapsulated | ( | const E_TransferSyntax | xfer | ) |
| private

check if this element should be written unencapsulated, even though an encapsulated transfer syntax is used.

In other words, this checks if this pixel data element is on the main level on the dataset or not.

Parameters

  xfer | the transfer syntax that should be used

## ◆ writeXML()

virtual OFCondition DcmPixelData::writeXML | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags = 0 )
| virtual

write object in XML format

Parameters

  out | output stream to which the XML document is written
  flags | optional flag used to customize the output (see DCMTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmOtherByteOtherWord.

## Member Data Documentation

## ◆ alwaysUnencapsulated

OFBool DcmPixelData::alwaysUnencapsulated
| private

this flag indicates that this pixel data element will be written in uncompressed (defined length) format even if the dataset itself is written in a compressed syntax where pixel data is normally written in encapsulated (undefined length) format.

By default this flag is false, unless the dataset was read in an encapsulated transfer syntax and this pixel data element was already present in uncompressed format.

## ◆ original

DcmRepresentationListIterator DcmPixelData::original
| private

Iterator to the original representation.

if an uncompressed representation is used the iterator points to repList.end()

The documentation for this class was generated from the following file:

- dcmdata/include/dcmtk/dcmdata/dcpixel.h

Generated on Sat Mar 1 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2